# i-Parapheur Server

[![build status](https://gitlab.libriciel.fr/i-parapheur/iparapheur-server/badges/develop/build.svg)](https://gitlab.libriciel.fr/i-parapheur/iparapheur-server/commits/develop) 
[![coverage report](https://gitlab.libriciel.fr/i-parapheur/iparapheur-server/badges/develop/coverage.svg)](https://gitlab.libriciel.fr/i-parapheur/iparapheur-server/commits/develop)

Partie serveur du i-Parapheur. 
Projet basé sur le SDK Alfresco version 3.0.

## Prérequis

Voir les [prérequis](http://docs.alfresco.com/community/concepts/alfresco-sdk-installing-prerequisite-software.html) du SDK

## Utilisation

Packaging du `war` :
```bash
mvn clean install
```

Lancement des tests :
```bash
mvn test                                                     # Unit-test
mvn verify            # Integration test
```

Lancement de l'application :
```bash
run.sh
```

# Alfresco Platform JAR Module - SDK 3

To run use `mvn clean install -DskipTests=true alfresco:run` or `./run.sh` and verify that it 

 * Runs the embedded Tomcat + H2 DB 
 * Runs Alfresco Platform (Repository)
 * Runs Alfresco Solr4
 * Packages both as JAR and AMP assembly
 
 Try cloning it, change the port and play with `enableShare`, `enablePlatform` and `enableSolr`. 
 
 Protip: This module will work just fine as a Share module if the files are changed and 
 if the enablePlatform and enableSolr is disabled.
 
# Few things to notice

 * No parent pom
 * WAR assembly is handled by the Alfresco Maven Plugin configuration
 * Standard JAR packaging and layout
 * Works seamlessly with Eclipse and IntelliJ IDEA
 * JRebel for hot reloading, JRebel maven plugin for generating rebel.xml, agent usage: `MAVEN_OPTS=-Xms256m -Xmx1G -agentpath:/home/martin/apps/jrebel/lib/libjrebel64.so`
 * AMP as an assembly
 * [Configurable Run mojo](https://github.com/Alfresco/alfresco-sdk/blob/sdk-3.0/plugins/alfresco-maven-plugin/src/main/java/org/alfresco/maven/plugin/RunMojo.java) in the `alfresco-maven-plugin`
 * No unit testing/functional tests just yet
 * Resources loaded from META-INF
 * Web Fragment (this includes a sample servlet configured via web fragment)
 
# TODO
 
  * Abstract assembly into a dependency so we don't have to ship the assembly in the archetype
  * Purge, 
  * Functional/remote unit tests
   
  
 
